//
// EntityReference.cpp
//
// $Id: //poco/1.4/XML/src/EntityReference.cpp#1 $
//
// Library: XML
// Package: DOM
// Module:  DOM
//
// Copyright (c) 2004-2006, Applied Informatics Software Engineering GmbH.
// and Contributors.
//
// Permission is hereby granted, free of charge, to any person or organization
// obtaining a copy of the software and accompanying documentation covered by
// this license (the "Software") to use, reproduce, display, distribute,
// execute, and transmit the Software, and to prepare derivative works of the
// Software, and to permit third-parties to whom the Software is furnished to
// do so, all subject to the following:
// 
// The copyright notices in the Software and this entire statement, including
// the above license grant, this restriction and the following disclaimer,
// must be included in all copies of the Software, in whole or in part, and
// all derivative works of the Software, unless such copies or derivative
// works are solely in the form of machine-executable object code generated by
// a source language processor.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
// SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
// FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
//


#include "Poco/DOM/EntityReference.h"


namespace Poco {
namespace XML {


EntityReference::EntityReference(Document* pOwnerDocument, const XMLString& name): 
	AbstractNode(pOwnerDocument),
	_name(name)
{
}


EntityReference::EntityReference(Document* pOwnerDocument, const EntityReference& ref): 
	AbstractNode(pOwnerDocument, ref),
	_name(ref._name)
{
}


EntityReference::~EntityReference()
{
}


const XMLString& EntityReference::nodeName() const
{
	return _name;
}


unsigned short EntityReference::nodeType() const
{
	return Node::ENTITY_REFERENCE_NODE;
}


Node* EntityReference::copyNode(bool deep, Document* pOwnerDocument) const
{
	return new EntityReference(pOwnerDocument, *this);
}


} } // namespace Poco::XML
